#!/usr/bin/env python

#Creates an empty old looking paper (GIMP plug-in)
#Copyright (c) 2008 by Sagenlicht from Cartographers Guild
#http://cartographersguild.com
# Version 1.0
#---------------------------------------------------------------------

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from gimpfu import *
import random

def createOldPaper(img, draw, paperColor):
	seedTexture = random.randrange(1,999999999)
	turbulenceTexture = 2.5
	bumpAzimuth = 135.0
	bumpElevation = 45.0
	bumpDepth = 5
	bumpOffX = 0
	bumpOffY = 0
	bumpWaterLvl = 0
	bumpAmbient = 0
	bumpCompensate = 1
	bumpInvert = 0
	bumpType = 0
		
	newLayer = gimp.Layer(img, "Paper", img.width, img.height, (RGBA_IMAGE, GRAYA_IMAGE)[img.base_type], 100.0, NORMAL_MODE)
	img.add_layer(newLayer, 0)
	pdb.gimp_edit_clear(newLayer)
	gimp.set_foreground(paperColor)
	pdb.gimp_edit_fill(newLayer, FOREGROUND_FILL)

	newLayer = gimp.Layer(img, "Texture", img.width, img.height, (RGBA_IMAGE, GRAYA_IMAGE)[img.base_type], 100.0, OVERLAY_MODE)
	img.add_layer(newLayer, 0)
	pdb.gimp_edit_clear(newLayer)

	pdb.plug_in_plasma(img, newLayer, seedTexture, turbulenceTexture)
	pdb.gimp_desaturate_full(newLayer, 0)

	pdb.plug_in_bump_map(img, newLayer, newLayer, bumpAzimuth, bumpElevation, bumpDepth, bumpOffX, bumpOffY, bumpWaterLvl, \
			bumpAmbient, bumpCompensate, bumpInvert, bumpType)

	newLayer = gimp.Layer(img, "Text", img.width, img.height, (RGBA_IMAGE, GRAYA_IMAGE)[img.base_type], 100.0, OVERLAY_MODE)
	img.add_layer(newLayer, 1)
	pdb.gimp_edit_clear(newLayer)

	newLayer = gimp.Layer(img, "Symbols", img.width, img.height, (RGBA_IMAGE, GRAYA_IMAGE)[img.base_type], 100.0, OVERLAY_MODE)
	img.add_layer(newLayer, 2)
	pdb.gimp_edit_clear(newLayer)


register(
	"python_fu_createOldPaper",
	"Creates an old looking paper",
	"Creates an old looking paper",
	"Christian Kremer",
	"Christian Kremer",
	"2008",
   "<Image>/Filters/RPG Filters/Create Old Paper",
	"RGB*, GRAY*",
	[
		(PF_COLOR, "paperColor", "Document Color", (208,193,162))
	],
	[],
	createOldPaper)


main()

